<?php

require_once ('super_model.php');

class Model_mobileapi extends super_model {

    public function varifyAppUser($username, $password) {
        $query1 = $this->db->query("SELECT *, COUNT(*) AS cnt FROM " . super_model::$table_users . " WHERE PassWord=" . $this->db->escape($password) . " AND Typ=" . $this->db->escape($username)." GROUP BY UName");
        $row1 = $query1->result_array();
        $counter = $row1[0]['cnt'];
        if ($counter > 0) {
            $query2 = $this->db->query("SELECT Name, Code FROM " . super_model::$table_master . " WHERE Name=" . $this->db->escape($username));
            if ($row2 = $query2->result_array()) {
                $query3 = $this->db->query("SELECT BillNo, NewBillNo FROM " . super_model::$table_master_details . " WHERE BillNo IN (SELECT MAX(BillNo) AS BillNo FROM " . super_model::$table_master_details . " WHERE Lorry = '$username' )");
                if ($row3 = $query3->result_array()) {
                    if ($row3[0]['BillNo'] == null || $row3[0]['NewBillNo'] == null) {
                        $result['BillNo'] = "0";
                        $result['NewBillNo'] = "0";
                    } else {
                        $result['BillNo'] = $row3[0]['BillNo'];
                        $result['NewBillNo'] = $row3[0]['NewBillNo'];
                    }
                    $result['cnt'] = $row1[0]['cnt'];
                    $result['Success'] = 1;
                    $result['Name'] = $row2[0]['Name'];
                    $result['Code'] = $row2[0]['Code'];
                    return $result;
                } else {
                    $result['BillNo'] = "0";
                    $result['NewBillNo'] = "0";
                    $result['cnt'] = $row1[0]['cnt'];
                    $result['Success'] = 1;
                    return $result;
                }
            } else {
                $result['cnt'] = 0;
                $result['Success'] = 0;
                return $result;
            }
        } else {
            $result['cnt'] = 0;
            $result['Success'] = 0;
            return $result;
        }
    }

    public function getPartyWithBalance() {
        $data = array();
        $query1 = $this->db->query("SELECT `Name`, `Code`, `Ph`, `CstNo`, `TinNo`, `Typ` ,`Address1`, `Address2`, `emp` FROM " . super_model::$table_master . "  GROUP BY `Name` ORDER BY `Name` ASC");
        $masterResult = $query1->result_array();
        for ($x = 0; $x < count($masterResult); $x++) {
            $i = $masterResult[$x]['Name'];
            $data[$i]["Name"] = $masterResult[$x]["Name"];
            $data[$i]["Code"] = $masterResult[$x]["Code"];
            $data[$i]["Ph"] = $masterResult[$x]["Ph"];
            $data[$i]["CstNo"] = $masterResult[$x]["CstNo"];
            $data[$i]["TinNo"] = $masterResult[$x]["TinNo"];
            $data[$i]["party_type"] = $masterResult[$x]["Typ"];
            $data[$i]["Address1"] = $masterResult[$x]["Address1"];
            $data[$i]["emp"] = $masterResult[$x]["emp"];
            $data[$i]["Opening"] = '0';
            $data[$i++]["Address2"] = $masterResult[$x]["Address2"];
        }
        $query2 = $this->db->query("SELECT PartyName, (SUM(NetTotal)-SUM(Amount)) AS Opening FROM " . super_model::$table_collection . " GROUP BY PartyName");
        $collectionResult = $query2->result_array();
        for ($j = 0; $j < count($collectionResult); $j++) {
            if (isset($data[$collectionResult[$j]['PartyName']])) {
                $data[$collectionResult[$j]['PartyName']]['Opening'] = $collectionResult[$j]['Opening'];
            }
        }
        return $data;
    }

    public function getProducts() {
        $this->db->select('*');
        $this->db->from(super_model::$table_sales_item);
        $query = $this->db->get();
        $data = $query->result_array();
        return $data;
    }

    public function getGodownStock($username) {
        $this->db->select('*');
        $this->db->where('godown', $username);
        $this->db->from(super_model::$table_godown_stock);
        $query = $this->db->get();
        $data = $query->result_array();
        return $data;
    }

    public function getUserPrevilage($username) {
        $this->db->select('*');
        $this->db->where('usr_name', $username);
        $this->db->from(super_model::$table_user_privilage);
        $query = $this->db->get();
        $data = $query->result_array();
        return $data;
    }

    public function updateSyncActivationStatus($username) {
        $data['apk_sync'] = 0;
        $this->db->where('usr_name', $username);
        $this->db->update(super_model::$table_user_privilage, $data);
    }

    public function getSynPrevilage($username) {
        $query = $this->db->query("SELECT apk_sync FROM " . super_model::$table_user_privilage . " WHERE usr_name = '$username'");
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["apk_sync"];
            } else {
                return false;
            }
        }
    }

    public function getEmployeeName() {
        $query = $this->db->query("SELECT DISTINCT Employee AS Name FROM " . super_model::$table_collection . " WHERE Employee IS NOT NULL ORDER BY Employee ASC");
        $data = $query->result_array();
        return $data;
    }

    public function getLocatioInfo($date1, $date2, $employeeName) {
        $query = $this->db->query("SELECT latitude,longitude FROM " . super_model::$table_mobile_app_gps . " WHERE date1 BETWEEN '$date1' AND '$date2' AND party_name ='$employeeName' ORDER BY id");
        $data = $query->result_array();
        return $data;
    }

    public function employeeWiseSalesReport($date1, $date2, $empName) {
        $query = $this->db->query("SELECT DISTINCT BillNo,NewBillNo,BillTime , BillPartyName AS PartyName, BillNetTotalField AS NetTotal,Lorry ,DATE_FORMAT(BillDate, '%d-%m-%Y') AS Date1 FROM " . super_model::$table_master_details . " WHERE BillDate BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND Lorry = '$empName'  ORDER BY BillNo ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["BillTime"] == null) {
                $data[$i]["BillTime"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["BillTime"];
        }
        return $data;
    }

    public function collectionReportEmployeeWise($date1, $date2, $empName) {
        $query = $this->db->query("SELECT SiNo AS BillNo,PartyName,bill_time, Amount, DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1, image_data FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND Employee ='$empName' AND Amount != 0 AND PartyName != '3' AND TransactionType !='ToSalesReturn' AND Typ='CUSTOMER' ORDER BY Date1 ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function collectionReport($date1, $date2) {
        $query = $this->db->query("SELECT SiNo AS BillNo,PartyName,bill_time, Amount, DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1, image_data FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND Amount != 0 AND PartyName!= '3' AND TransactionType !='ToSalesReturn' AND Typ='CUSTOMER' ORDER BY Date1 ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function openingReport($date1) {
        $query = $this->db->query("SELECT SUM(Amount),SUM(NetTotal) FROM " . super_model::$table_collection . " WHERE Date1 < '$date1' AND (TransactionType ='Cash' || TransactionType ='Cheque' ||  TransactionType ='RTGS' || TransactionType ='DD' || TransactionType ='Recieved ByCash')");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function cashBookReport($date1, $date2) {
        $query = $this->db->query("SELECT SiNo,bill_time,DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1,PartyName,Amount,NetTotal FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1' AND '$date2' AND
                                (TransactionType ='Cash' || TransactionType ='Cheque' ||  TransactionType ='RTGS' || TransactionType ='DD' || TransactionType ='Recieved ByCash')");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function purchaseReport($date1, $date2) {
        $query = $this->db->query("SELECT BillNo,bill_time,DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1,PartyName,Amount FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1' AND '$date2' AND TransactionType ='ToCash'");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function salesReport($date1, $date2) {
        $query = $this->db->query("SELECT DISTINCT BillNo,bill_time,PartyName,NetTotal, DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1 FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND TransactionType='ToSales'  ORDER BY BillNo ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function orderReport($date1, $date2) {
        $query = $this->db->query("SELECT DISTINCT BillNo,BillTime,BillPartyName,BillNetTotalField, DATE_FORMAT(BillDate, '%d-%m-%Y') AS BillDate FROM " . super_model::$table_master_details8B . "  WHERE BillDate BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' ORDER BY BillNo ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["BillTime"] == null) {
                $data[$i]["BillTime"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["BillDate"] . " " . $data[$i]["BillTime"];
        }
        return $data;
    }

    public function employeeWiseorderReport($date1, $date2, $empName) {
        $query = $this->db->query("SELECT DISTINCT BillNo,BillTime,BillPartyName,BillNetTotalField, DATE_FORMAT(BillDate, '%d-%m-%Y') AS BillDate FROM " . super_model::$table_master_details8B . "  WHERE BillDate BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND Lorry = '$empName' ORDER BY BillNo ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["BillTime"] == null) {
                $data[$i]["BillTime"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["BillDate"] . " " . $data[$i]["BillTime"];
        }
        return $data;
    }

    public function employeeWiseAuditingReport($empName) {
        $query = $this->db->query("SELECT SUM(Opening) AS Amt FROM " . super_model::$table_master . " WHERE emp = '$empName' ");
        $result = $query->row();
        $opngAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(tot) AS Amt FROM (SELECT SUM(total) AS tot FROM " . super_model::$table_godown_trance . " WHERE dest = '$empName' GROUP BY vcr_no )AS tabil");
        $result = $query->row();
        $stockAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(Amount) AS Amt FROM " . super_model::$table_collection . " WHERE Employee = '$empName' AND (TransactionType ='Cash' || TransactionType ='Cheque' ||  TransactionType ='RTGS' || TransactionType ='DD') AND Typ = 'CUSTOMER'");
        $result = $query->row();
        $receiptAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(NetTotal) AS Amt FROM " . super_model::$table_collection . " WHERE Employee = '$empName' AND (TransactionType ='Cash' || TransactionType ='Cheque' ||  TransactionType ='RTGS' || TransactionType ='DD') AND Typ = 'EXPENSE'");
        $result = $query->row();
        $expenceAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(BillDiscAmtField) + SUM(TDiscAmt) AS Amt FROM " . super_model::$table_master_details . " WHERE Lorry = '$empName'");
        $result = $query->row();
        $discountAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(net_total) AS Amt FROM " . super_model::$table_godown_trance . " WHERE src = '$empName' ");
        $result = $query->row();
        $returnAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(amount) AS Amt FROM (SELECT qty*cst AS amount FROM " . super_model::$table_godown_stock . " WHERE godown = '$empName' GROUP BY item,cst) AS tabil;");
        $result = $query->row();
        $stockGdAmt = $result->Amt;

        $query = $this->db->query("SELECT SUM(NetTotal) - SUM(Amount) AS Amt FROM " . super_model::$table_collection . " WHERE  Employee = '$empName' AND Typ = 'CUSTOMER';");
        $result = $query->row();
        $creditAmt = $result->Amt;

        $res = array();
        $res['opening_amt'] = $opngAmt;
        $res['stock_amt'] = $stockAmt;
        $res['receipt'] = $receiptAmt;
        $res['expence'] = $expenceAmt;
        $res['discount'] = $discountAmt;
        $res['return'] = $returnAmt;
        $res['van_stock'] = $stockGdAmt;
        $res['credit'] = $creditAmt;
        return $res;
    }

    public function ledger($date1, $date2, $partyName) {
        $query = $this->db->query("SELECT bill_time, DATE_FORMAT(Date1, '%d-%m-%Y') AS Date1, Amount AS debit , NetTotal AS credit FROM " . super_model::$table_collection . " WHERE Date1 BETWEEN '$date1 00:00:00' AND '$date2 23:59:59' AND PartyName= '$partyName' AND  Typ='CUSTOMER' ");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["bill_time"] == null) {
                $data[$i]["bill_time"] = "";
            }
            $data[$i]["dateTime"] = $data[$i]["Date1"] . " " . $data[$i]["bill_time"];
        }
        return $data;
    }

    public function currentStockReport($empName) {
        $query = $this->db->query("SELECT ItemNameTextField,godown_wise_stock.qty AS StockInMain,Cost,curr_stock * Cost AS TotalCost FROM " . super_model::$table_sales_item . " RIGHT JOIN " . super_model::$table_godown_wise_stock . " ON `ItemNameTextField` = godown_wise_stock.Item ORDER BY ItemNameTextField ASC;");
        $data = $query->result_array();
        return $data;
    }

    public function currentStockReportEMPWise($empName) {
        $query = $this->db->query("SELECT ItemNameTextField,godown_wise_stock.qty AS StockInMain,Cost,curr_stock * Cost AS TotalCost FROM " . super_model::$table_sales_item . " RIGHT JOIN " . super_model::$table_godown_wise_stock . " ON `ItemNameTextField` = godown_wise_stock.Item WHERE godown_wise_stock.godown = '$empName' ORDER BY ItemNameTextField ASC;");
        $data = $query->result_array();
        return $data;
    }

    public function getSalesDetailsForBillno($billNumber) {
        $query = $this->db->query("SELECT Item, Qty, Rate,Total,TaxA, NetV,local_app_user_entry_id FROM " . super_model::$table_sales_bill . " WHERE BillNo = '$billNumber' ");
        $data = $query->result_array();
        return $data;
    }

    public function getItemWiseSalesReport($date1, $date2) {
        $query = $this->db->query("SELECT   Item,SUM( Qty) AS Qty,SUM( Total) AS Total FROM " . super_model::$table_sales_bill . " WHERE SBDate BETWEEN '$date1' AND '$date2'  GROUP BY Item ");
        $data = $query->result_array();
        return $data;
    }

    public function getUpdateBillNo($inv_no, $emp) {
        $query = $this->db->query("SELECT BillNo FROM " . super_model::$table_master_details . " WHERE NewBillNo  = '$inv_no' AND Lorry = '$emp'");
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["BillNo"];
            } else {
                return false;
            }
        }
    }

    public function getBillNo() {
        $query = $this->db->query("SELECT MAX(BillNo+1) AS BillNo FROM " . super_model::$table_master_details);
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["BillNo"];
            } else {
                return false;
            }
        }
    }

    public function getSiNo() {
        $query = $this->db->query("SELECT MAX(SiNo+1) AS SiNo FROM " . super_model::$table_collection);
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["SiNo"];
            } else {
                return false;
            }
        }
    }

    public function deleteFromMasterDetailsByBillNo($luserEntryID, $billNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('BillNo!=', $billNo);
        $this->db->delete(super_model::$table_sr_master_details);
    }

    public function deleteFromSalesBillByBillNo($invno, $employee) {
        $this->db->where('local_app_invoice_id =', $invno);
        $this->db->where('GoodsOn', $employee);
        $this->db->delete(super_model::$table_sales_bill);
    }
   
    public function deleteFromMasterDetailsToSalesBillDelete($inv_no, $emp) {
        $this->db->where('NewBillNo =', $inv_no);
        $this->db->where('Lorry', $emp);
        $this->db->delete(super_model::$table_master_details);
    }
    
     public function deleteFromCollectionToSaleBillDelete($billNo) {
        $this->db->where('TransactionType', 'ToSales');
        $this->db->where('BillNo =', $billNo);
        $this->db->delete(super_model::$table_collection);
    }
    
    public function deleteFromCollectionByBillNo($luserEntryID, $billNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('BillNo!=', $billNo);
        $this->db->delete(super_model::$table_collection);
    }

    public function storeUser($itemName, $price, $qty, $unit, $party, $godown, $employee, $date1, $invno, $local_app_user_entry_id, $billNo, $index, $taxAmt, $taxPerc, $itemC, $qty_in_pack, $cost, $disc) {
        if ($this->db->query("DELETE FROM " . super_model::$table_sales_bill . " WHERE local_app_user_entry_id='$local_app_user_entry_id' AND  BillNo != '$billNo'")) {
            $total = ($price - $disc) * $qty;
            $netV = $total + $taxAmt;
            $data = array(
                'SiNo' => $index,
                'ItemC' => $itemC,
                'Item' => $itemName,
                'Qty' => $qty,
                'sqft' => '0',
                'Rate' => $price,
                'ItWiseDisAmt' => '0',
                'Dis' => $disc,
                'Total' => $total,
                'NetV' => $netV,
                'GoodsOn' => $employee,
                'BillNo' => $billNo,
                'SBDate' => $date1,
                'Cst' => $cost,
                'BillTyp' => '8',
                'Stat' => '0',
                'local_app_user_entry_id' => $local_app_user_entry_id,
                'local_app_invoice_id' => $invno,
                'TaxP' => $taxPerc,
                'TaxA' => $taxAmt,
                'Unit' => $unit,
                'Pack' => $qty_in_pack
            );
            $this->db->insert(super_model::$table_sales_bill, $data);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                return FALSE;
            }
        }
    }

    public function storeGPS($latitude, $longitude, $party_name, $action, $date1, $user, $godown) {
        $data = array(
            'latitude' => $latitude,
            'longitude' => $longitude,
            'party_name' => $party_name,
            'action' => $action,
            'date1' => $date1,
            'user' => $user,
            'godown' => $godown
        );
        $this->db->insert(super_model::$table_mobile_app_gps, $data);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function getSRBillNo() {
        $query = $this->db->query("SELECT IFNULL (MAX(RetNo+1),0) AS retNo FROM " . super_model::$table_sales_return);
	
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
					$data = array(
            'RetNo' => $row[0]["retNo"],
        );
		$this->db->insert(super_model::$table_sales_return, $data);
                return $row[0]["retNo"];
            } else {
                return false;
            }
        }
    }

    public function deleteFromSRMasterDetailsByRetNo($luserEntryID, $retNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('RetNo!=', $retNo);
        $this->db->delete(super_model::$table_sr_master_details);
    }

    public function deleteFromCollectionByRetNo($luserEntryID, $retNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('RetNo!=', $retNo);
        $this->db->delete(super_model::$table_collection);
    }

    public function storeSalesRetunCollection($RetNo, $dates, $BillPartyName, $BillTotalField, $BillNetTotalField, $Employee, $godown, $local_app_user_entry_id, $TaxAmt) {
        if ($this->db->query("DELETE FROM " . super_model::$table_collection . " WHERE local_app_user_entry_id='$local_app_user_entry_id' ")) {
            $data = array(
                'BillNo' => $RetNo,
                'TransactionType' => 'ToSalesReturn',
                'Date1' => $dates,
                'PartyName' => $BillPartyName,
                'Amount' => $BillNetTotalField,
                'Employee' => $Employee,
                'Typ' => 'CUSTOMER',
                'BillForm' => '8',
                'godown' => $Employee,
                'local_app_user_entry_id' => $local_app_user_entry_id
            );
            $this->db->insert(super_model::$table_collection, $data);
            $insert_id = $this->db->insert_id();
            return $insert_id;
        } else {
            $data = array(
                'BillNo' => $OrderLines,
                'TransactionType' => 'ToSalesReturn',
                'Date1' => $dates,
                'PartyName' => $BillPartyName,
                'Amount' => $BillNetTotalField,
                'Employee' => $Employee,
                'Typ' => 'CUSTOMER',
                'BillForm' => '8',
                'godown' => $Employee,
                'local_app_user_entry_id' => $local_app_user_entry_id
            );
            $this->db->insert(super_model::$table_collection, $data);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                return FALSE;
            }
        }
    }

    public function getUpdateQueryMasterDetails($BillNo, $BillDate, $BillPartyName, $BillTotalField, $BillDiscAmtField, $BillDiscPercField, $BillTaxField, $BillPackageField, $BillNetTotalField, $BillTyp, $BillTime, $OrderNo, $TDiscAmt, $TaxAmt, $TItTaxAmt, $TAmt, $Cess, $Lorry, $DCNoTax, $TotDiscPercAmt, $CessP, $TotItWiseQty1, $CashP, $CashCard, $CashCardAmt, $godown, $del_date, $local_app_user_entry_id, $EmpCode, $NewBillNo, $SystemId) {
        $data['BillNo'] = $BillNo;
//        $data['BillDate'] = $BillDate;
        $data['BillPartyName'] = $BillPartyName;
        $data['BillTotalField'] = $BillTotalField;
        $data['BillDiscAmtField'] = $BillDiscAmtField;
        $data['BillDiscPercField'] = $BillDiscPercField;
        $data['BillTaxField'] = $BillTaxField;
        $data['BillPackageField'] = $BillPackageField;
        $data['BillNetTotalField'] = $BillNetTotalField;
        $data['BillTyp'] = $BillTyp;
//        $data['BillTime'] = $BillTime;
        $data['OrderNo'] = $OrderNo;
        $data['TDiscAmt'] = $TDiscAmt;
        $data['TaxAmt'] = $TaxAmt;
        $data['TItTaxAmt'] = $TItTaxAmt;
        $data['TAmt'] = $TAmt;
        $data['Cess'] = $Cess;
        $data['Lorry'] = $Lorry;
        $data['DCNoTax'] = $DCNoTax;
        $data['TotDiscPercAmt'] = $TotDiscPercAmt;
        $data['CessP'] = $CessP;
        $data['TotItWiseQty1'] = $TotItWiseQty1;
        $data['CashP'] = $CashP;
        $data['CashCard'] = $CashCard;
        $data['CashCardAmt'] = $CashCardAmt;
        $data['godown'] = $godown;
//        $data['del_date'] = $del_date;
        $data['local_app_user_entry_id'] = $local_app_user_entry_id;
        $data['EmpCode'] = $EmpCode;
//        $data['NewBillNo'] = $NewBillNo;
        $data['SystemId'] = $SystemId;
        $this->db->where('Lorry', $Lorry);
        $this->db->where('NewBillNo', $NewBillNo);
        $this->db->update(super_model::$table_master_details, $data);
        if ($this->db->affected_rows() == 1) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
    
    public function getUpdateQueryCollection($BillNo, $BillDate, $BillPartyName, $BillNetTotalField, $Lorry) {
//        $data['BillNo'] = $BillNo;
//        $data['Date1'] = $BillDate;
        $data['PartyName'] = $BillPartyName;
        $data['NetTotal'] = $BillNetTotalField;
        $data['Typ'] = 'CUSTOMER';
        $data['BillForm'] = '8';
        $data['godown'] = $Lorry;
        $data['Stat'] = '1';
        $this->db->where('BillNo', $BillNo);
        $this->db->where('TransactionType', 'ToSales');
        $this->db->where('Typ', 'CUSTOMER');
        $this->db->where('BillForm', '8');
        $this->db->update(super_model::$table_collection, $data);
        if ($this->db->affected_rows() == 1) {
            return TRUE;
        } else {
            return FALSE;
        }
    }
    
    public function getQuery($tableName, $dbData) {
        $isFirstItem = true;
        $query = "INSERT INTO " . $tableName . "(";
        $keyQuery = "";
        $valueQuery = ") VALUES(";
        foreach ($dbData as $key => $value) {
            if ($key == "upload_status") {
                continue;
            }
            if ($isFirstItem) {
                $keyQuery = $keyQuery . $key;
                $valueQuery = $valueQuery . "'" . $value . "'";
                $isFirstItem = false;
            } else {
                $keyQuery = $keyQuery . "," . $key;
                $valueQuery = $valueQuery . ",'" . $value . "'";
            }
        }
        $valueQuery = $valueQuery . ")";
        $query = $query . $keyQuery . $valueQuery;
        $data = $this->db->query($query);
        $insert_id = $this->db->insert_id();
        if ($this->db->affected_rows() == 1) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    public function storeSalesRetun($itemName, $price, $qty, $unit, $party, $godown, $employee, $date1, $invno, $local_app_user_entry_id, $retNo, $index, $taxAmt, $taxPerc, $itemC, $qty_in_pack, $cost, $disc) {
        if ($this->db->query("DELETE FROM " . super_model::$table_sales_return . " WHERE local_app_user_entry_id='$local_app_user_entry_id' AND  RetNo != '$retNo'")) {
            $total = ($price - $disc) * $qty;
            $netV = $total + $taxAmt;
            $data = array(
                'SiNo' => $index,
                'ItemC' => $itemC,
                'Item' => $itemName,
                'Qty' => $qty,
                'sqft' => $cost,
                'Rate' => $price,
                'Dis' => $disc,
                'Tot' => $total,
                'TaxP' => $taxPerc,
                'TaxA' => $taxAmt,
                'Total' => $netV,
                'RetNo' => $retNo,
                'SBDate' => $date1,
                'Stat' => '0',
                'godown' => $employee,
                'local_app_user_entry_id' => $local_app_user_entry_id,
                'Unit' => $unit,
                'Pack' => $qty_in_pack
            );
            $this->db->insert(super_model::$table_sales_return, $data);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                return FALSE;
            }
        }
    }

    public function getOrderBillNo() {
        $query = $this->db->query("SELECT MAX(BillNo+1) AS BillNo FROM " . super_model::$table_master_details8B);
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["BillNo"];
            } else {
                return false;
            }
        }
    }

    public function deleteFromMasterDetails8BByBillNo($luserEntryID, $billNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('BillNo!=', $billNo);
        $this->db->delete(super_model::$table_master_details8B);
    }

    public function storeOrderUser($itemName, $price, $qty, $unit, $party, $godown, $employee, $date1, $invno, $local_app_user_entry_id, $billNo, $index, $taxAmt, $taxPerc, $itemC, $qty_in_pack) {
        if ($this->db->query("DELETE FROM " . super_model::$table_sales_bill8B . " WHERE local_app_user_entry_id='$local_app_user_entry_id' AND  BillNo != '$billNo'")) {
            $total = $price * $qty;
            $netV = $total + $taxAmt;
            $data = array(
                'SiNo' => $index,
                'ItemC' => $itemC,
                'Item' => $itemName,
                'Qty' => $qty,
                'sqft' => '0',
                'Rate' => $price,
                'ItWiseDisAmt' => '0',
                'Dis' => '0',
                'Total' => $total,
                'NetV' => $netV,
                'GoodsOn' => $godown,
                'BillNo' => $billNo,
                'SBDate' => $date1,
                'Cst' => '0',
                'BillTyp' => '8B',
                'Stat' => '0',
                'local_app_user_entry_id' => $local_app_user_entry_id,
                'local_app_invoice_id' => $invno,
                'TaxP' => $taxPerc,
                'TaxA' => $taxAmt,
                'Pack' => $qty_in_pack,
                'Unit' => $unit,
            );
            $this->db->insert(super_model::$table_sales_bill8B, $data);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                return FALSE;
            }
        }
    }

    public function addNewParty($name, $code, $address1, $address2, $mobNo, $gstNumber, $stateAndCode, $balance, $user, $dateTime, $local_app_user_entry_id, $partyType) {
        $data = array(
            'Name' => $name,
            'Typ' => $partyType,
            'Code' => $code,
            'Address1' => $address1,
            'Address2' => $address2,
            'TinNo' => $gstNumber,
            'CstNo' => $stateAndCode,
            'Salary' => 'DAILY',
            'Bank' => 'CURRENT',
            'Opening' => $balance,
            'Stat' => '0',
            'emp' => $user,
            'Ph' => $mobNo,
            'local_app_user_entry_id' => $local_app_user_entry_id
        );
        $this->db->insert(super_model::$table_master, $data);
        $insert_id = $this->db->insert_id();
        if ($this->db->affected_rows() == 1) {
            $data2 = array(
                'Date1' => $dateTime,
                'PartyName' => $name,
                'NetTotal' => $balance,
                'TransactionType' => 'Opening',
                'Typ' => $partyType,
                'Stat' => '0',
                'Employee' => $user,
                'Amount' => '0'
            );
            $this->db->insert(super_model::$table_collection, $data2);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                $this->db->where('Typ', 'CUSTOMER');
                $this->db->where('Name', $name);
                $this->db->delete(super_model::$table_master);
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }

    public function storeDebit($party, $amount, $date1, $user, $godown, $image_data, $transaction_type, $cheque_no, $narration, $local_app_user_entry_id, $SiNo) {
        $billTime = date("h:i A", strtotime($date1));
        $date1 = date("Y-m-d", strtotime($date1)) . " 00:00:00";
        $query = $this->db->query("SELECT COUNT(*) AS cnt FROM " . super_model::$table_collection . " WHERE local_app_user_entry_id ='$local_app_user_entry_id'");
        if ($row = $query->result_array()) {
            if ($row[0]['cnt'] < 1) {
                $data2 = array(
                    'SiNo' => $SiNo,
                    'TransactionType' => $transaction_type,
                    'Date1' => $date1,
                    'PartyName' => $party,
                    'Amount' => $amount,
                    'Employee' => $user,
                    'Typ' => 'CUSTOMER',
                    'CashFlow' => 'DEBIT',
                    'godown' => 'MAIN',
                    'Stat' => '0',
                    'ChequeNo' => $cheque_no,
                    'Narration' => $narration,
                    'image_data' => $image_data,
                    'bill_time' => $billTime,
                    'local_app_user_entry_id' => $local_app_user_entry_id
                );
                $this->db->insert(super_model::$table_collection, $data2);
                $insert_id = $this->db->insert_id();
                if ($this->db->affected_rows() == 1) {
                    return TRUE;
                } else {
                    return FALSE;
                }
            } else {
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }

    public function storeCredit($party, $amount, $date1, $user, $godown, $transaction_type, $cheque_no, $narration, $local_app_user_entry_id, $SiNo) {
        $billTime = date("h:i A", strtotime($date1));
        $date1 = date("Y-m-d", strtotime($date1)) . " 00:00:00";
        $query = $this->db->query("SELECT COUNT(*) AS cnt FROM " . super_model::$table_collection . " WHERE local_app_user_entry_id ='$local_app_user_entry_id'");
        if ($row = $query->result_array()) {
            if ($row[0]['cnt'] < 1) {
                $data2 = array(
                    'SiNo' => $SiNo,
                    'TransactionType' => $transaction_type,
                    'Date1' => $date1,
                    'PartyName' => $party,
                    'NetTotal' => $amount,
                    'Employee' => $user,
                    'Typ' => 'PURCHASE PARTY',
                    'CashFlow' => 'CREDIT',
                    'godown' => 'MAIN',
                    'Stat' => '0',
                    'ChequeNo' => $cheque_no,
                    'Narration' => $narration,
                    // 'image_data' => $image_data,
                    'bill_time' => $billTime,
                    'local_app_user_entry_id' => $local_app_user_entry_id
                );
                $this->db->insert(super_model::$table_collection, $data2);
                $insert_id = $this->db->insert_id();
                if ($this->db->affected_rows() == 1) {
                    return TRUE;
                } else {
                    return FALSE;
                }
            } else {
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }



    public function storeExpense($party, $amount, $date1, $user, $godown, $transaction_type, $cheque_no, $narration, $local_app_user_entry_id, $SiNo) {
        $billTime = date("h:i A", strtotime($date1));
        $date1 = date("Y-m-d", strtotime($date1)) . " 00:00:00";
        $query = $this->db->query("SELECT COUNT(*) AS cnt FROM " . super_model::$table_collection . " WHERE local_app_user_entry_id ='$local_app_user_entry_id'");
        if ($row = $query->result_array()) {
            if ($row[0]['cnt'] < 1) {
                $data2 = array(
                    'SiNo' => $SiNo,
                    'TransactionType' => $transaction_type,
                    'Date1' => $date1,
                    'PartyName' => $party,
                    'NetTotal' => $amount,
                    'Employee' => $user,
                    'Typ' => 'EXPENSE',
                    'CashFlow' => 'CREDIT',
                    'godown' => 'MAIN',
                    'Stat' => '0',
                    'ChequeNo' => $cheque_no,
                    'Narration' => $narration,
                    'bill_time' => $billTime,
                    'local_app_user_entry_id' => $local_app_user_entry_id
                );
                $this->db->insert(super_model::$table_collection, $data2);
                $insert_id = $this->db->insert_id();
                if ($this->db->affected_rows() == 1) {
                    return TRUE;
                } else {
                    return FALSE;
                }
            } else {
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }





    public function storeProduct($itemname, $itemcode, $stock, $user, $godown, $base_rate_retail, $sec_rate_retail, $base_unit, $sec_unit, $category, $img, $tax, $base_rate_wholesale, $sec_rate_wholesale, $qty_in_pack, $local_app_user_entry_id, $Cost, $SecCostRate, $StockInMain, $Rate3, $prod_typ, $CostRs, $Disc, $DiscP, $Color) {
        $billTime = date("h:i A");
        $date1 = date("Y-m-d") . " 00:00:00";
        $query2 = $this->db->query("SELECT COUNT(*) AS itemNameCount FROM " . super_model::$table_sales_item . " WHERE ItemNameTextField ='$itemname'");
        if ($itemName = $query2->result_array()) {
            if ($itemName[0]['itemNameCount'] < 1) {
                $query = $this->db->query("SELECT COUNT(*) AS cnt FROM " . super_model::$table_sales_item . " WHERE local_app_user_entry_id ='$local_app_user_entry_id'");
                $query1 = $this->db->query("SELECT MAX( ItemNo ) + 1 AS itemNo FROM " . super_model::$table_sales_item);
                $itemNo = $query1->result_array();
                if ($row = $query->result_array()) {
                    if ($row[0]['cnt'] < 1) {
                        $data2 = array(
                            'ItemNo' => $itemNo[0]['itemNo'],
                            'ItemNameTextField' => $itemname,
                            'ItemC' => $itemcode,
                            'StockInMain' => $StockInMain,
                            'StockInGoDown' => '0',
                            'Cost' => $Cost,
                            'Rate1' => $base_rate_retail,
                            'Rate2' => $base_rate_wholesale,
                            'Rate3' => $Rate3,
                            'Disc' => $Disc,
                            'Tax1' => $tax,
                            'DiscP' => $DiscP,
                            'Color' => $Color,
                            'Size' => $category,
                            'MfgDate' => $date1,
                            'CostRs' => $CostRs,
                            'Typ' => $base_unit,
                            'Stat' => '0',
                            'Pack' => $qty_in_pack,
                            'prod_typ' => $prod_typ,
                            'photo' => $img,
                            'RatePerInch' => '0',
                            'photo1' => '0',
                            'curr_stock' => $stock,
                            'SecUnit' => $sec_unit,
                            'SecCostRate' => $SecCostRate,
                            'SecRetailRate' => $sec_rate_retail,
                            'SecWholesaleRate' => $sec_rate_wholesale,
                            'local_app_user_entry_id' => $local_app_user_entry_id,
                            'empCode' => $user
                        );
                        $this->db->insert(super_model::$table_sales_item, $data2);
                        $insert_id = $this->db->insert_id();
                        if ($this->db->affected_rows() == 1) {
                            return TRUE;
                        } else {
                            return FALSE;
                        }
                    } else {
                        return FALSE;
                    }
                } else {
                    return FALSE;
                }
            } else {
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }

    public function getPurchaseInvNo() {
        $query = $this->db->query("SELECT MAX(InvoiceNo+1) AS invNo FROM " . super_model::$table_Pbill);
        if ($query->num_rows() > 0) {
            if ($row = $query->result_array()) {
                return $row[0]["invNo"];
            } else {
                return false;
            }
        }
    }

    public function deleteFromPBillByInvoNo($luserEntryID, $billNo) {
        $this->db->where('local_app_user_entry_id', $luserEntryID);
        $this->db->where('PBillNo!=', $billNo);
        $this->db->delete(super_model::$table_purchase_bill);
    }

    public function storePurchaseBill($itemName, $price, $qty, $unit, $party, $godown, $employee, $date1, $invno, $local_app_user_entry_id, $invNO, $index, $taxAmt, $taxPerc, $itemC, $qty_in_pack) {
        if ($this->db->query("DELETE FROM " . super_model::$table_purchase_bill . " WHERE local_app_user_entry_id='$local_app_user_entry_id' AND  PBillNo != '$invNO'")) {
            $total = $price * $qty;
            $netV = $total + $taxAmt;
            $data = array(
                'PBillNo' => $invNO,
                'PSiNo' => $index,
                'ItemC' => $itemC,
                'PItem' => $itemName,
                'PQty' => $qty,
                'sqft' => '0',
                'PRate' => $price,
                'PDis' => '0',
                'PTotal' => $total,
                'PTaxP' => $taxPerc,
                'PTaxA' => $taxAmt,
                'PNetV' => $total,
                'Perc' => '0',
                'MRP' => '0',
                'SRP' => '0',
                'PGoodsOn' => 'MAIN',
                'PBDate' => $date1,
                'Stat' => '0',
                'Pack' => $qty_in_pack,
                'Unit' => $unit,
                'local_app_user_entry_id' => $local_app_user_entry_id
            );
            $this->db->insert(super_model::$table_purchase_bill, $data);
            $insert_id = $this->db->insert_id();
            if ($this->db->affected_rows() == 1) {
                return TRUE;
            } else {
                return FALSE;
            }
        }
    }

    public function listParty() {
        $query = $this->db->query("SELECT Name, Code, Ph, (SUM(NetTotal)-SUM(Amount)) AS Opening FROM " . super_model::$table_master . " LEFT JOIN " . super_model::$table_collection . " ON Master.Name = Collection.PartyName WHERE  Master.Typ = 'CUSTOMER'  GROUP BY Master.Name ORDER BY NAME ASC");
        $data = $query->result_array();
        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]["Opening"] == null) {
                $data[$i]["Opening"] = "";
            }
        }
        return $data;
    }

    public function deleteFromMaster($typ, $name) {
        $this->db->where('Typ', $typ);
        $this->db->where('Name', $name);
        $this->db->delete(super_model::$table_master);
    }

    public function deleteFromCollection($TransactionType, $typ, $name) {
        $this->db->where('TransactionType', $TransactionType);
        $this->db->where('Typ', $typ);
        $this->db->where('PartyName', $name);
        $this->db->delete(super_model::$table_collection);
    }

    public function getPartyByName($name) {
        $query = $this->db->query("SELECT * FROM " . super_model::$table_master . " WHERE Typ='CUSTOMER' AND Name='$name'");
        $data = $query->result_array();
        return $data;
    }

}